Package net.sf.saxon.value

## Class SequenceSlice

- java.lang.Object
- - net.sf.saxon.value.SequenceSlice

- All Implemented Interfaces:
    `GroundedValue`, `Sequence`

      public class SequenceSlice
      extends java.lang.Object
      implements GroundedValue

  A sequence value implemented extensionally. That is, this class represents a sequence by allocating memory to each item in the sequence.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SequenceSlice​(java.util.List<? extends Item> value, int offset, int length)` | Construct an sequence from a slice of a list of items.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.Iterable<? extends Item>` | `asIterable()` | Get the contents of this value in the form of a Java `Iterable`, so that it can be used in a for-each expression
    `int` | `getCardinality()` | Determine the cardinality
    `int` | `getLength()` | Get the number of items in the sequence
    `java.lang.String` | `getStringValue()` | Get the string value of this sequence.
    `java.lang.CharSequence` | `getStringValueCS()` | Get the string value of this sequence.
    `Item` | `head()` | Get the first item in the sequence.
    `Item` | `itemAt​(int n)` | Get the n'th item in the sequence (starting with 0 as the first item)
    `ListIterator<? extends Item>` | `iterate()` | Return an iterator over this sequence.
    `java.util.Iterator<? extends Item>` | `iterator()` | Get an iterator (a Java `Iterator`) over the items in this sequence.
    `GroundedValue` | `reduce()` | Reduce the sequence to its simplest form.
    `GroundedValue` | `subsequence​(int start, int length)` | Get a subsequence of the value
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `concatenate, containsNode, effectiveBooleanValue, materialize, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

- - ### Constructor Detail

    - #### SequenceSlice

          public SequenceSlice​(java.util.List<? extends Item> value,
                               int offset,
                               int length)

      Construct an sequence from a slice of a list of items. Note, the list of items is used as is, which means the caller must not subsequently change its contents.
      Parameters:
        `value` - the list of items
        `offset` - the zero-based position of the first item to be included in the sequence
        `length` - the number of items to be included in the sequence; if this exceeds the number of items available for inclusion, include all items up to the end of the sequence
      Throws:
        `java.lang.IndexOutOfBoundsException` - if offset < 0 or length < 0 or offset + length < value.size()

  - ### Method Detail

    - #### getStringValue

          public java.lang.String getStringValue()
                                          throws XPathException

      Description copied from interface: `GroundedValue`
      Get the string value of this sequence. The string value of an item is the result of applying the string() function. The string value of a sequence is the space-separated result of applying the string-join() function using a single space as the separator
      Specified by:
        `getStringValue` in interface `GroundedValue`
      Returns:
        the string value of the sequence.
      Throws:
        `XPathException` - if the sequence contains items that have no string value (for example, function items)

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()
                                                  throws XPathException

      Description copied from interface: `GroundedValue`
      Get the string value of this sequence. The string value of an item is the result of applying the string() function. The string value of a sequence is the space-separated result of applying the string-join() function using a single space as the separator
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Returns:
        the string value of the sequence.
      Throws:
        `XPathException` - if the sequence contains items that have no string value (for example, function items)

    - #### head

          public Item head()

      Get the first item in the sequence.
      Specified by:
        `head` in interface `GroundedValue`
      Specified by:
        `head` in interface `Sequence`
      Returns:
        the first item in the sequence if there is one, or null if the sequence is empty

    - #### getLength

          public int getLength()

      Get the number of items in the sequence
      Specified by:
        `getLength` in interface `GroundedValue`
      Returns:
        the number of items in the sequence

    - #### getCardinality

          public int getCardinality()

      Determine the cardinality
      Returns:
        the cardinality of the sequence, using the constants defined in net.sf.saxon.value.Cardinality
      See Also:
        `Cardinality`

    - #### itemAt

          public Item itemAt​(int n)

      Get the n'th item in the sequence (starting with 0 as the first item)
      Specified by:
        `itemAt` in interface `GroundedValue`
      Parameters:
        `n` - the position of the required item
      Returns:
        the n'th item in the sequence, or null if the position is out of range

    - #### iterate

          public ListIterator<? extends Item> iterate()

      Return an iterator over this sequence.
      Specified by:
        `iterate` in interface `GroundedValue`
      Specified by:
        `iterate` in interface `Sequence`
      Returns:
        the required SequenceIterator, positioned at the start of the sequence

    - #### subsequence

          public GroundedValue subsequence​(int start,
                                           int length)

      Get a subsequence of the value
      Specified by:
        `subsequence` in interface `GroundedValue`
      Parameters:
        `start` - the index of the first item to be included in the result, counting from zero. A negative value is taken as zero. If the value is beyond the end of the sequence, an empty sequence is returned
        `length` - the number of items to be included in the result. Specify Integer.MAX_VALUE to get the subsequence up to the end of the base sequence. If the value is negative, an empty sequence is returned. If the value goes off the end of the sequence, the result returns items up to the end of the sequence
      Returns:
        the required subsequence. If min is

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### reduce

          public GroundedValue reduce()

      Reduce the sequence to its simplest form. If the value is an empty sequence, the result will be EmptySequence.getInstance(). If the value is a single atomic value, the result will be an instance of AtomicValue. If the value is a single item of any other kind, the result will be an instance of One. Otherwise, the result will typically be unchanged.
      Specified by:
        `reduce` in interface `GroundedValue`
      Returns:
        the simplified sequence

    - #### asIterable

          public java.lang.Iterable<? extends Item> asIterable()

      Get the contents of this value in the form of a Java `Iterable`, so that it can be used in a for-each expression
      Specified by:
        `asIterable` in interface `GroundedValue`
      Returns:
        an Iterable containing the same sequence of items

    - #### iterator

          public java.util.Iterator<? extends Item> iterator()

      Get an iterator (a Java `Iterator`) over the items in this sequence.
      Returns:
        an iterator over the items in this sequence.